/**
 * HXITCE.java
 *
 * File generated from the medication::HXITCE uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class HXITCE.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "HXIT_CE", propOrder = {
	"validTime"
})
@XmlRootElement(name = "HXIT_CE")
public class HXITCE extends net.ihe.gazelle.medication.CE implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                          The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                      .
	 */
	@XmlElement(name = "validTime", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.IVLTS validTime;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return validTime.
	 * @return validTime :                          The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                      
	 */
	public net.ihe.gazelle.medication.IVLTS getValidTime() {
	    return validTime;
	}
	
	/**
	 * Set a value to attribute validTime.
	 * @param validTime :                          The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                                               The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                      .
	 */
	public void setValidTime(net.ihe.gazelle.medication.IVLTS validTime) {
	    this.validTime = validTime;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "HXIT_CE").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(HXITCE hXITCE, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (hXITCE != null){
   			net.ihe.gazelle.medication.CE.validateByModule(hXITCE, location, cvm, diagnostic);
			net.ihe.gazelle.medication.IVLTS.validateByModule(hXITCE.getValidTime(), location + "/validTime", cvm, diagnostic);
    	}
    }

}